<template>
    <div v-if="!isLoaded && !isLoadedMore && link" >
        <div class="header-page">
            <div class="title">
                {{ film.name}}
            </div>
            <div class="options">
                <div v-if="film.favorite" class="btn btn-primary btn-favorite" title="Удалить из избранных" @click="removeFavorite"><i class="fas fa-star"></i></div>
                <div v-else class="btn btn-default btn-favorite" title="Добавить в избранные" @click="addFavorite"><i class="far fa-star"></i></div>
            </div>
        </div>
        <div class="body-page">
            <div class="view-video" id="viewFilm" >
                <film-player v-if="link && !isLoadedLink" :frame="frameImg" :link="link" :start="film.not_ended ? film.end_time : 0" @playing="onPlaying" @statistic="sendStatistics"></film-player>
                <div v-else class="video-js">
                    <div class="loading-container"><div class="loading-box"></div></div>
                </div>

                <div class="name-series" v-if="seriesName">{{seriesName}}</div>
            </div>
            <div class="claim">
                <div class="btn" @click="showModal = true">Оставить жалобу</div>

                <div class="right-part">
                    <div class="list-quality" v-if="film.quality">
                        <div class="title">
                            Качество:
                        </div>
                        <div class="quality" v-for="qual in film.quality" :class="qual.url == film.link ? 'active':''" @click="setQuality(qual)">{{qualitys[qual.quality]}}</div>
                    </div>
                    <div class="likes" v-if="film.votes">
                        <div class="btn ico-like" :class="parseInt(film.votes.user_like) ? 'active':''" @click="sendLike"><span v-if="1 > 0">- {{film.votes.likes}}</span></div>
                        <div class="btn ico-dislike" :class="parseInt(film.votes.user_dislike) ? 'active':''" @click="sendDislike"><span v-if="1 > 0">- {{film.votes.dislike}}</span></div>
                    </div>
                </div>
            </div>
            <div class="seasons series" v-if="film.seasons.length > 1">
                <div class="item-series seasons" v-for="season in film.seasons" :class="{'active' : (+chosenSeason === +season)}"  @click="loadSeason(season)" > Сезон {{season}} </div>
            </div>
            <div class="series" v-if="series.length > 0">
                <div class="item-series" v-for="serie in series" :class="{'active' : (+activeSeries === +serie.series_number && +activeSeason === +serie.season_number)}"  @click="loadNewSeries(serie)" > Серия {{serie.series_number}}  </div>
            </div>

            <div class="info info-film">
                <div class="cover">
                    <img :src="this.$store.state.host + film.cover" alt="" />
                </div>
                <div class="other">
                    <div class="genres"><span class="title">Жанр:</span>
                        <router-link v-for="genre in film.genres_ids" :to="{name: 'FilmsIndex', params: {genreFilter: getGenre(genre)}}">
                            {{ getGenre(genre).title }}
                        </router-link>
                    </div>
                    <div class="country"><span class="title">Страна: </span> {{film.more.country}}</div>
                    <div class="year"><span class="title">Год: </span> <router-link :to="{name: 'FilmsIndex', query: {'year': film.year} }">{{film.year}} </router-link></div>
                    <div class="director" v-if="film.director"><span class="title">Режисер: </span>
                        <router-link v-for="director in film.director.split(', ')" :to="{name: 'FilmsIndex', query: {'director': director} }">{{director}}</router-link>
                    </div>
                    <div class="actors" v-if="film.actors"><span class="title">Актеры: </span>
                        <router-link v-for="actor in film.actors.split(', ')" :to="{name: 'FilmsIndex', query: {'actor': actor} }">{{actor}}, </router-link>
                    </div>
                    <div class="description"><span class="title">Описание: </span> {{film.description}}</div>
                    <div class="description"><span class="title">Ограничение возраста: </span>
                        <span v-if="!+film.censored"> нет </span>
                        <span v-else>18+</span>
                    </div>
                    <div class="description" v-if="film.rating_kinopoisk"><span class="title">Рейтинг Кинопоиск:</span> {{film.rating_kinopoisk}}</div>
                    <div class="description" v-if="film.rating_imdb"><span class="title">Рейтинг IMDb:</span> {{film.rating_imdb}}</div>
                </div>
            </div>
            <div class="gallery" v-if="film.more.screenshots && film.more.screenshots.length > 0">
                <div class="item-slide" v-for="item in film.more.screenshots">
                    <img :src="item" alt="" />
                </div>
            </div>
            <div class="social">
                <div class="title-soc">Поделиться:</div>
                <social-sharing :networks="overriddenNetworks"
                                inline-template>
                    <div class="social-list">
                        <network network="facebook">        Facebook        </network>
                        <network network="vk">              VK              </network>
                        <network network="twitter">         Twitter         </network>
                        <network network="odnoklassniki">   Odnoklassniki   </network>
                        <network network="skype">           Skype           </network>
                        <network network="telegram">        Telegram        </network>
                        <network network="whatsapp">        Whatsapp        </network>
                    </div>
                </social-sharing>
            </div>
            <div class="comments">
<!--                <vue-disqus :shortname="https-xakinfo-ru" :identifier="'film'+film.id" :language="'ru'"></vue-disqus>-->
            </div>
        </div>
        <div class="modal" v-if="showModal">
            <div class="back-modal" @click="showModal = false"></div>
            <div class="body-claim" v-if="!sendClaim">
                <h4>Возникли проблемы?</h4>
                <h4>Сообщите нам об этом!</h4>
                <div class="list-form">
                    <div class="item-form">
                        <div class="label">Видео</div>
                        <div class="value">
                            <div class="radio">
                                <input type="radio" id="vGood" value="good" v-model="claim.video">
                                <label for="vGood">Хорошо</label>
                            </div>
                            <div class="radio">
                                <input type="radio" id="vBad" value="bad" v-model="claim.video">
                                <label for="vBad">Плохо</label>
                            </div>
                        </div>
                    </div>
                    <div class="item-form">
                        <div class="label">Аудио</div>
                        <div class="value">
                            <div class="radio">
                                <input type="radio" id="sGood" value="good" v-model="claim.sound">
                                <label for="sGood">Хорошо</label>
                            </div>
                            <div class="radio">
                                <input type="radio" id="sBad" value="bad" v-model="claim.sound">
                                <label for="sBad">Плохо</label>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="bottom-form">
                    <div class="btn" @click="sendMyClaim">Сообщить</div>
                </div>
            </div>
            <div class="body-claim" v-else>
                <h4>Спасибо, Ваша оценка учтена!</h4>
                <div class="bottom-form">
                    <div class="btn" @click="clearForm">Закрыть</div>
                </div>
            </div>
        </div>
    </div>
    <div v-else class="loading-container"><div class="loading-box"></div></div>
</template>

<script>
    import FilmPlayer from "@/components/players/FilmPlayer";
    import 'videojs-hotkeys';

    export default {
        components: {FilmPlayer},
        name: "filmView",
        data() {
            return {
                length: 0,
                activeSeries: 1,
                activeSeason: 1,
                chosenSeason: 1,
                timeNow: 0,
                defaultQuality: '6',
                sendClaim: false,
                showModal: false,
                flagLink: false,
                flagLoad: false,
                statisticFlag: false,
                claim: {
                    sound: 'good',
                    video: 'good',
                },
                seriesNames: '',
                frameImg: '',
            }
        },
        computed: {
            id() {
                return this.$route.params.id
            },
            film() {
                let film = this.$store.getters.getFilm( this.id );
                if (this.frameImg === '' && film.frames && film.frames[0].is_serial !== '1') {
                    this.frameImg = film.frames[0].frames;
                } else if(this.frameImg === '' && film.frames && film.not_ended === 0) {
                    this.frameImg = film.frames[0].episodes.filter(item => +item.series_number === this.activeSeries && +item.season_number === this.activeSeason )[0].frames ;
                }
                return film
            },
            seriesName() {
                return this.seriesNames ? this.seriesNames : this.film.more.episodes && this.film.more.episodes[0].series_name ? this.film.more.episodes[0].series_name : '';
            },
            currentTime() {
                return parseInt( this.timeNow > 0 ? this.timeNow : this.film.end_time ? this.film.end_time : 0 );
            },
            qualitys() {
                return this.$store.state.qualitys
            },
            series() {
                if (this.film.more.episodes) {
                    return this.film.more.episodes.filter((t) => (
                            +t.season_number === +this.chosenSeason
                        )
                    );

                } else {
                    return []
                }
            },
            isLoaded() {
                return this.$store.getters.isLoading('film') ;
            },
            isLoadedMore() {
                return this.$store.getters.isLoading('filmMore') ;
            },
            isLoadedLink() {
                let notEnded = this.film.not_ended_episode ? this.film.not_ended_episode.split('909809') : [false, false];
                if (!this.flagLoad && this.film.more.is_serial !== "0" && notEnded[0] !== false) {
                    if (+notEnded[0] !== +this.activeSeason || +this.activeSeries !== +notEnded[1]) {
                        let ne = this.film.more.episodes.filter(item => +item.series_number === +notEnded[1] && +item.season_number === +notEnded[0] );
                        console.log('ne',ne);
                        this.loadOldSeries( ne[0] );
                    }
                }
                return this.$store.getters.isLoading('link');
            },
            overriddenNetworks() {
                return {
                    url: window.location,
                    title: 'TV company - ' + this.film.name,
                    description: this.film.description,
                    media: this.$store.state.host + this.film.cover
                }
            },
            link() {
                return this.film.link ? this.film.link : this.film.more.url ? this.film.more.url : false;
            }
        },
        created () {
            window.addEventListener('beforeunload', (event) => {
                // event.returnValue = 'You have unfinished changes!';
            });
        },
        methods: {
            onPlaying(length, current){
                this.length = Math.trunc(length);
                this.timeNow = Math.trunc(current);
            },
            getGenre(id) {
                return this.$store.getters.getFilmGenre(id);
            },
            addFavorite() {
                this.$store.dispatch('addFavoriteFilm', this.id);

            },
            removeFavorite() {
                this.$store.dispatch('removeFavoriteFilm', this.id);
            },
            loadSeason(season) {
                this.chosenSeason = season;
            },
            loadSeries(series) {
                let params = {'id':this.id, 'indexSeries':series};
                this.$store.dispatch('loadSerialLink', params );
                this.activeSeries = series;
            },
            loadOldSeries(series) {
                this.$store.dispatch('commitSerialLink', {data: series.url, id: this.id} );
                this.activeSeries = series.series_number;
                this.activeSeason = series.season_number;
                this.seriesNames = series.series_name;
                this.flagLoad = true;

                this.frameImg = this.film.frames[0].episodes.filter(item => +item.series_number === +series.series_number && +item.season_number === +series.season_number )[0].frames;
            },
            loadNewSeries(series) {
                this.setEndTime(0);

                this.$store.dispatch('commitSerialLink', {data: series.url, id: this.id} );
                this.activeSeries = series.series_number;
                this.activeSeason = series.season_number;
                this.seriesNames = series.series_name;

                this.frameImg = this.film.frames[0].episodes.filter(item => +item.series_number === +series.series_number && +item.season_number === +series.season_number )[0].frames;

            },
            setQuality(q) {
                this.$store.dispatch('commitSerialLink', {data: q.url, id: this.id} );
                this.defaultQuality = q.quality;
            },
            setEndTime(time) {
                this.$store.commit('setFilmEnded', {data: time, id: this.id} );
            },
            sendMyClaim() {
                this.sendClaim = true;
                this.$store.dispatch('sendClaim', {id: this.id, claim: this.claim});
            },
            clearForm() {
                this.sendClaim = false;
                this.showModal = false;
                this.claim.video = 'good';
                this.claim.sound = 'good';
            },
            sendStatistics() {
                if (!this.statisticFlag) {
                    this.statisticFlag = true;
                    let self = this;
                    setTimeout(function () {
                        self.dispatchStatistic();
                    }, 600000)
                }
            },
            dispatchStatistic() {
                let params = {
                    id: parseInt(this.id),
                    uid: this.$store.state.User.id
                };
                this.$store.dispatch('sendStatisticVideo', params);
            },
            sendLike() {
                let params = {
                    id: parseInt(this.id),
                    like: 1
                };
                this.$store.dispatch('likeFilmVotes', params);
            },
            sendDislike() {
                let params = {
                    id: parseInt(this.id),
                    like: 0
                };
                this.$store.dispatch('likeFilmVotes', params);

            }
        },
        mounted() {

        },
        beforeMount() {

            this.$store.dispatch('loadFilmAllInfo', this.$route.params.id);

            if (!!this.film && this.film.not_ended !== 0 && this.film.series.length > 0 && this.film.more) {
                let notEnded = this.film.not_ended_episode.split('909809');
                this.activeSeason = +notEnded[0];
                this.chosenSeason = +notEnded[0];
                this.activeSeries = +notEnded[1];
                let ne = this.film.more.episodes.filter(item => +item.series_number === +notEnded[1] && +item.season_number === +notEnded[0] )
                this.loadOldSeries( ne[0] );
            } else {
                this.$store.dispatch('loadFilmLink', this.$route.params.id);
            }

        },
        beforeRouteLeave (to, from, next) {
            if ( (this.length-this.currentTime) !== 0 && this.film.series.length > 0) {
                this.$store.dispatch('notEndedSeries', {id: this.id, time:this.currentTime, episode: this.activeSeason+'909809'+this.activeSeries });
            } else if ( (this.length-this.currentTime) > 120 && this.currentTime > 60 ) {
                this.$store.dispatch('notEnded', {id: this.id, time:this.currentTime});
            } else if (this.film.not_ended !== 0) {
                this.$store.dispatch('destroyNotEnded', this.id );
            }
            next()
        }
    }
</script>



<style lang="scss">
    .view-video {
        position: relative;

        .vjs-playing {
            z-index: 3;
        }
        .name-series {
            position: absolute;
            bottom: 50px;
            font-size: 42px;
            width: 100%;
            left: 0;
            text-align: center;
            font-family: Gil-SB, serif;
            z-index: 2;
        }
    }
    .description {
        white-space: pre-line;
    }
</style>
<style scoped lang="scss">


    .claim {
        margin-top: 10px;
        display: flex;
        align-items: center;
        justify-content: space-between;
        flex-wrap: wrap;

        .btn {
            margin: 5px 0;

            &:hover {
                background: #0a4882;
                border-color: #0a4882;
                color: #fff;
            }
        }

        .right-part {
            margin-left: auto;
            display: flex;
            align-items: center;
            flex-wrap: wrap;

            .btn {
                margin: 0 5px;
                padding: 0 5px !important;
                font-size: 16px;
                min-width: 50px;
                border: 0;

                &.ico-like:before {
                    content: '';
                    display: block;
                    width: 25px;
                    height: 25px;
                    margin-bottom: 5px;
                    background: url(/images/like.svg) no-repeat center;
                    background-size: contain;
                    margin-left: 2px;
                    margin-right: 5px;
                }
                &.ico-dislike:before {
                    content: '';
                    display: block;
                    width: 25px;
                    height: 25px;
                    margin-top: 5px;
                    background: url(/images/dislike.svg) no-repeat center;
                    background-size: contain;
                    margin-left: 4px;
                    margin-right: 5px;
                }

                &:last-child {
                    margin-right: 0;
                }

                &.active {
                    background: #0a4882;
                }
            }
        }
        .likes {
            display: flex;
            align-items: center;
        }
        .list-quality {
            display: flex;
            align-items: center;

            .title {
                font-family: Gil-SB, serif;
            }

            .quality {
                padding: 5px;
                opacity: 0.5;
                cursor: pointer;

                &.active {
                    opacity: 1;
                }
            }
        }
    }
    .btn {
        border: 1px solid #fff
    }
    .light .btn {
        border-color: #0a4882;
    }
    .modal {
        position: fixed;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        z-index: 9999999;
        display: flex;
        align-items: center;
        justify-content: center;
        overflow: auto;
        padding: 20px;

        .bottom-form {
            margin-top:20px;
        }

        .back-modal {
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            z-index: 1;
            background: rgba(255, 255, 255, 0.5);
        }

        .body-claim {
            position: relative;
            z-index: 100;
            padding: 20px;
            background: #0E202C;
            color: #fff;
            text-align: center;

            h4 {
                margin-bottom: 10px;
                line-height: 1;
                font-family: NS-B, serif;
            }

            .list-form {
                text-align: left;
                margin-top: 15px;

                .item-form {
                    margin-bottom: 12px;

                    .label {
                        font-weight: 900;
                        font-size: 18px;
                        margin-bottom: 8px;
                    }
                    .value {
                        display: flex;
                        align-items: center;

                        .radio {
                            width: 50%;

                            input[type="radio"] {
                                display: none;
                            }
                            input[type="radio"] + label {
                                display: flex;
                                align-items: center;

                                &:before {
                                    content: '';
                                    display: block;
                                    min-width: 15px;
                                    max-width: 15px;
                                    height: 15px;
                                    border: 2px solid #fff;
                                    border-radius: 50%;
                                    margin-right: 7px;
                                    box-shadow:
                                            inset 0 0 0 4px #fff,
                                            inset 0 0 0 8px #fff;
                                }
                            }
                            input[type="radio"]:checked + label {

                                &:before {
                                    background: #000;
                                    box-shadow:
                                            inset 0 0 0 4px #0E202C,
                                            inset 0 0 0 8px #fff;
                                }
                            }
                        }
                    }
                }
            }
        }

    }


    .series {
        display: flex;
        flex-wrap: wrap;
        margin: 20px 0 0;
    }
    .series .item-series {
        padding: 5px 10px;
        border: 1px solid #fff;
        margin: 0 10px 10px 0;
        cursor: pointer;
    }
    .series .item-series.active {
        border: 1px solid #4383bf;
        color: #4383bf;
    }

    .btn-favorite {
        padding:  0 20px !important;
        font-size: 21px;
        transition-duration: .3s;
    }
    .btn-default.btn-favorite {
        color: #478dcd;
    }

    .info-film {
        display: flex;
        padding: 25px 0 0;
    }
    .info-film a:hover {
        text-decoration: underline;
    }
    .info-film .cover {
        min-width: 240px;
        max-width: 240px;
        margin-right: 20px;
    }
    .info-film .cover img{
        width: 100%;
    }
    .info-film .other > div {
        margin-bottom: 10px;
    }
    .info-film .other > div .title {
        font-family: NS-B, serif;

    }
    .gallery {
        display: flex;
        flex-wrap: wrap;
        margin: 20px 0;

        .item-slide {
            margin: 0 15px 15px 0;

            img {
                height: 150px;
            }
        }
    }
    .video-js {
        width: 100% !important;
        height: calc( (100vw - 150px)*9 /16) !important;
        max-height: calc(100vh - 230px);
    }

    .back-step {
        background: url('/static/images/back.svg') no-repeat 50% 50%;
        background-size: contain;
        width: 30px;
        height: 30px;
        margin-right: 10px;
        cursor: pointer;
    }

    .social {
        margin: 15px 0 0 auto;
        text-align: right;
    }
    .social .title-soc {
        font-family: NS-B, serif;
        font-size: 18px;
    }
    .social .title-soc .social-list {
        justify-content: flex-end;
    }
    .social .title-soc .social-list span {
        margin-left: 10px;
    }


    .social .social-list span {
        margin-left: 10px;
        cursor: pointer;
    }
    .social .social-list span:hover {
        background: #0a4882;
    }

    .header-page {
        display: flex;
        align-items: center;
        justify-content: space-between;

        .title {
            width: initial;
            margin-right: 10px;
        }
    }

    @media (max-width: 1000px) {
        .view-video .name-series {
            bottom: 20px;
            font-size: 21px;
            padding: 0 10px;
        }
    }
    @media (max-width: 760px) {
        .info-film {
            flex-wrap: wrap;
        }
        .info-film > div {
            width: 100%;
            margin: 0 0 15px;
        }
        .info-film > div.cover {
            text-align: center;
            min-width: 100%;
            max-width: 100%;
        }
        .info-film > div.cover img {
            width: initial;
            max-width: 100%;
        }
    }

    @media (max-width: 600px) {
        .video-js {
            height: calc( (100vw - 50px)*9 /16) !important;
        }

        .view-video .name-series {
            bottom: 0;
            font-size: 16px;
            padding: 5px 10px;
            background: rgba(0,0,0,0.5);

        }
    }

</style>
